#!/system/bin/bash -x
SN_NUMBER=$(getprop ro.serialno | busybox cut -d "," -f 1)		
PCB_NAME=`ntx_hwconfig-static -s /dev/block/mmcblk0 PCB | busybox cut -d= -f 2`

dump_uboot(){
		echo "---> Programming uboot -----------------------------------------------"
		sync
		sync
		if [ $PCB_NAME = "'E606E0'" ] ; then
			busybox dd if=/cache/upgrade/u-boot_E606E2.bin of=/dev/block/mmcblk0 bs=1K seek=1 skip=1
		elif [ $PCB_NAME = "'E606H2'" ] ; then
			busybox dd if=/cache/upgrade/u-boot_E606H2.bin of=/dev/block/mmcblk0 bs=1K seek=1 skip=1
		else
			echo "---> ERROR ! Unknown PCB name"
		fi
		sync
		sync
		rm /cache/upgrade/u-boot_E606E2.bin
		rm /cache/upgrade/u-boot_E606H2.bin
		sync
		sync
}

dump_kernel(){
		echo "---> Programming kernel ----------------------------------------------"
		sync
		sync
		busybox dd if=/cache/upgrade/uImage of=/dev/block/mmcblk0 bs=1M seek=1
		sync
		sync
		rm /cache/upgrade/uImage
		sync
		sync
}

dump_ramdisk(){
		echo "---> Programming ramdisk rootfs --------------------------------------"
		sync
		sync
		busybox dd if=/cache/upgrade/uramdisk.img of=/dev/block/mmcblk0 bs=1M seek=6
		sync
		sync
		rm /cache/upgrade/uramdisk.img
		sync
		sync
}

dump_hw_config(){
		echo "---> Dump hw_config ----------------------------------------"
		sync
		sync
		busybox dd if=/cache/upgrade/hw_config.bin of=/dev/block/mmcblk0 bs=512 seek=1024
		sync
		sync
		rm /cache/upgrade/hw_config.bin
		sync
		sync
}

dump_logo(){
#LOGO_START=45056 #22MB
#POWERLOW_START=46080 #22.5MB
		echo "---> Dump logo ----------------------------------------"
		sync
		sync
        #45056*512-16 = 23068656
		busybox dd if=/cache/upgrade/logo.jpg.header of=/dev/block/mmcblk0 bs=1 seek=23068656
		busybox dd if=/cache/upgrade/logo.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=45056
		# busybox dd if=/cache/upgrade/logo.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=18432
		sync
		sync
		rm /cache/upgrade/logo.jpg.raw4
		rm /cache/upgrade/logo.jpg.header
		sync
		sync
		#46080*512-16 = 23592944
		busybox dd if=/cache/upgrade/powerlow.jpg.header of=/dev/block/mmcblk0 bs=1 seek=23592944
		busybox dd if=/cache/upgrade/powerlow.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=46080
		# busybox dd if=/cache/upgrade/powerlow.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=19456
		sync
		sync
		rm /cache/upgrade/powerlow.jpg.raw4
		rm /cache/upgrade/powerlow.jpg.header
		sync
		sync
}

dump_logo_non_reagl(){
#LOGO_START=18432 #9MB
#POWERLOW_START=19456 #9.5MB
		echo "---> Dump logo ----------------------------------------"
		sync
		sync
        #18432*512-16 = 9437168
		busybox dd if=/cache/upgrade/logo.jpg.header of=/dev/block/mmcblk0 bs=1 seek=9437168
		busybox dd if=/cache/upgrade/logo.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=18432
		sync
		sync
		rm /cache/upgrade/logo.jpg.raw4
		rm /cache/upgrade/logo.jpg.header
		sync
		sync
		#19456*512-16 = 9961456
		busybox dd if=/cache/upgrade/powerlow.jpg.header of=/dev/block/mmcblk0 bs=1 seek=9961456
		busybox dd if=/cache/upgrade/powerlow.jpg.raw4 of=/dev/block/mmcblk0 bs=512 seek=19456
		sync
		sync
		rm /cache/upgrade/powerlow.jpg.raw4
		rm /cache/upgrade/powerlow.jpg.header
		sync
		sync
}

dump_sn(){
		echo "---> Dump sn ----------------------------------------"
		sync
		sync
		busybox dd if=/dev/zero of=/dev/block/mmcblk0 bs=512 seek=1 count=1
		sync
		sync
		busybox dd if=/cache/upgrade/sn.out of=/dev/block/mmcblk0 bs=512 seek=1 count=1
		sync
		sync
		rm /cache/upgrade/sn.out
		sync
		sync
}

disk_check(){
		echo "---> file system check ---------------------------------"
		sync
		sync
		e2fsck -dy /dev/block/mmcblk0p2
		e2fsck -dy /dev/block/mmcblk0p4
		e2fsck -dy /dev/block/mmcblk0p5
		e2fsck -dy /dev/block/mmcblk0p6
		sync
		sync
}

dump_upgrade_mode(){
		echo "---> Upgrade mode ------------------------------------------------"
		sync
		sync
 		rm -r /cache/upgrade
		mkdir /cache/upgrade

		if [ "$1" = "emergency" ]  ; then
				busybox unzip -o /orig_update.zip u-boot_E606E2.bin u-boot_E606H2.bin uImage uramdisk.img hw_config.bin logo.jpg.raw4 logo.jpg.header powerlow.jpg.raw4 powerlow.jpg.header sn.out -d /cache/upgrade
		else
		if [ -e /cache/update.zip ] ; then
				busybox unzip -o /cache/update.zip u-boot_E606E2.bin u-boot_E606H2.bin uImage uramdisk.img hw_config.bin logo.jpg.raw4 logo.jpg.header powerlow.jpg.raw4 powerlow.jpg.header sn.out -d /cache/upgrade
		elif [ -e /sdcard/extsd/update.zip ] ; then
				busybox unzip -o /sdcard/extsd/update.zip u-boot_E606E2.bin u-boot_E606H2.bin uImage uramdisk.img hw_config.bin logo.jpg.raw4 logo.jpg.header powerlow.jpg.raw4 powerlow.jpg.header sn.out -d /cache/upgrade
		fi
		fi
		sync
		sync
		sleep 5
		dump_uboot
		dump_kernel
		dump_ramdisk
		dump_hw_config
		
		echo $SN_NUMBER
		if [ $SN_NUMBER != "" ]
		then {
		    if [ $SN_NUMBER -gt "20311240" ] || [ $SN_NUMBER -eq "00000200" ] ; then
		            echo "This device is using reagl waveform"
		            dump_logo
		    else
		            echo "This device is using non-reagl waveform"
		            dump_logo_non_reagl
		    fi
		}
		else {
		    echo "Serial number is empty"
		}
		fi
		
		disk_check
		if [ -e /cache/upgrade/sn.out ] ; then
				dump_sn
		fi

#		if [ "$1" != "emergency" ]  ; then
#		if [ -e /sdcard/extsd/update.zip ] ; then
#			busybox touch /sdcard/extsd/update_mark
#		fi
#		fi

		if [ "$1" = "emergency" ] || [  "$1" = "clean_sdcard" ]  ; then
				ls -a /sdcard | while read line
				do
						if [ "${line}" = "extsd" ]  ; then
								continue
						else
								echo "rm -rf /sdcard/${line}"
								busybox rm -rf "/sdcard/${line}"
						fi

				done
		fi

#		if [ -e /data/apk/update_apk.tgz ] ; then
#				mkdir /extsd/apk_tmp
#				busybox tar -zxvf /data/apk/update_apk.tgz -C /extsd/apk_tmp
#				busybox cp /extsd/apk/q90614_old.lst /extsd/apk_tmp
#				busybox rm -r /extsd/apk
#				busybox mv /extsd/apk_tmp /extsd/apk
#		fi
		echo "---> Wipe /data/data ------------------------------------------------"
		ls -a /data/data | while read line
		do
		echo "rm -rf /data/data/${line}/lib"
		busybox rm -rf "/data/data/${line}/lib/*"
		done
}

dump_upgrade_mode "$1"

